/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: SplashScreen.cpp,v 1.13 2003/11/23 14:36:09 comix Exp $
 *
 */


#include "SplashScreen.h"

/**
 * Constructor
 */
//SplashScreen::SplashScreen() : QWidget( 0, "HydrogenSplashScreen", Qt::WStyle_Splash ) {
SplashScreen::SplashScreen() : QWidget( 0, "HydrogenSplashScreen", Qt::WStyle_NoBorder | Qt::WStyle_StaysOnTop| Qt::WX11BypassWM ) {


//	cout << "init splashscreen" << endl;

	setMinimumSize(width, height);
	setMaximumSize(width, height);
	resize(width, height);

	setCaption( trUtf8( "Hydrogen" ) );
	string icon_path = string( IMG_PATH ) + string( "/img/icon32.png" );
	setIcon( QPixmap( icon_path.c_str() ) );

	string logo_path = string( IMG_PATH ) + string( "/img/splash/splash.png" );
	QPixmap logo = QPixmap(logo_path.c_str());

	QFont font;
	font.setPointSize( 10 );
	font.setBold( true );

	QPainter p( &logo );
	p.setFont( font );
	p.setPen( QColor( 70, 70, 70 ) );

	string version = string(VERSION) + " (" + string(__DATE__) + ")";
	p.drawText( 20, 100, QString( version.c_str() ) );

	string alphaVersion = string( trUtf8("Alpha Version ").latin1() );
	p.drawText( 20, 130, QString( alphaVersion.c_str() ) );

	string featuresTxt = string( trUtf8("Modules: ").latin1() ) + string(COMPILED_FEATURES);
	p.drawText( 20, 293, QString( featuresTxt.c_str() ) );

	QLabel *logoLbl = new QLabel(this);
	logoLbl->move(0, 0);
	logoLbl->resize(400, 300);
	logoLbl->setPixmap(logo);

	QTimer::singleShot( 1000, this, SLOT( closeSplash() ) );

}




/**
 * Destructor
 */
SplashScreen::~SplashScreen() {
//	cout << "destroy splashscreen" << endl;
}



/**
 * Close the splash screen
 */
void SplashScreen::closeSplash() {
//	cout << "close splash" << endl;
	hide();
}



