#include "config.h"

#include <iostream>
#include <stdio.h>
#include <string>
using std::string;

#include "../lib/Hydrogen.h"
#include "../lib/LocalFileMng.h"
#include "../lib/PreferencesMng.h"
#include "../lib/EngineListener.h"
#include "../lib/LadspaFX.h"

using std::cout;
using std::endl;

void usage() {
	cout << "Usage: hydrogenPlayer song.h2song" << endl;
}


int main(int argc, char** argv) {
	if (argc != 2) {
		usage();
		exit(0);
	}
	cout << "Hydrogen player starting..." << endl << endl;

	string filename = argv[1];

	Song *song = Song::load(filename);
	if (song == NULL) {
		cout << "Error loading song!" << endl;
		exit(0);
	}

/*
	vector<LadspaFXInfo*> info = LadspaFX::getPluginList();
	for (uint i = 0; i < info.size(); i++) {
		cout << i << " - " << info[i]->sName << " - " << info[i]->sLabel << endl;
		cout << "\t" << "in = " << info[i]->nIAPorts << "\tout = " << info[i]->nOAPorts << endl;
		cout << "\t" << info[i]->sFilename << endl;
	}
*/

	Hydrogen *engine = Hydrogen::getInstance();
	engine->setSong(song);

	engine->start();
	cout << "press q for quit" << endl;

	char pippo;


	while (true) {
		cout << "notes = " << engine->getPlayingNotes() << "     \r";
		cout.flush();
		usleep(500);


		pippo = getchar();
		if (pippo == 'q') {
			cout << endl << "HydrogenPlayer shutdown..." << endl;
			break;
		}

	}

	engine->stop();

	delete engine;
	engine = NULL;

	delete song;
	song = NULL;

	PreferencesMng *pref = PreferencesMng::getInstance();
	delete pref;
	pref = NULL;

	// ladspa
//	for (uint i = 0; i < info.size(); i++) {
//		delete info[ i ];
//	}


	int nObj = Object::getNObjects();
	std::cout << std::endl << std::endl << nObj << " alive objects" << std::endl << std::endl;

	return 0;
}



